

&IF defined(DEBUG) > 0 &THEN
  PROCEDURE displayProgress.
    DEF INPUT PARAM pcProgram AS CHAR NO-UNDO.
    DEF INPUT PARAM pcAction  AS CHAR NO-UNDO.
    DEF INPUT PARAM pcTable   AS CHAR NO-UNDO.
    DEF INPUT PARAM piTotal   AS INT  NO-UNDO.
    DEF INPUT PARAM piDone    AS INT  NO-UNDO.
  END PROCEDURE.
&ELSE
 {System/conversion/conversion_progress.i}
&ENDIF

DEFINE VARIABLE cProgram  AS CHARACTER NO-UNDO FORMAT "x(50)".
DEFINE VARIABLE cAction   AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE cTable    AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE iTotal    AS INTEGER   NO-UNDO.
DEFINE VARIABLE iDone     AS INTEGER   NO-UNDO.
DEFINE VARIABLE iTel      AS INTEGER   NO-UNDO.

DEF VAR sp-companycode AS CHAR NO-UNDO.
DEF VAR glTasksCreated AS LOG  NO-UNDO.
DEF VAR gcDialogueList AS CHAR NO-UNDO.
DEF VAR gcGacType      AS CHAR NO-UNDO.
DEF VAR gcGacVendor    AS CHAR NO-UNDO.
DEF VAR gcGacDes       AS CHAR NO-UNDO.
DEF VAR gcGacCode      AS CHAR NO-UNDO.

DEF BUFFER b-wm-ssd                 FOR wm-ssd              .
DEF BUFFER b-wm-ssd_compound        FOR wm-ssd_compound     .
DEF BUFFER b-wm-ssd_gac             FOR wm-ssd_gac          .
DEF BUFFER b-wm-ssd_gate            FOR wm-ssd_gate         .
DEF BUFFER b-wm-ssd_gate_terminal   FOR wm-ssd_gate_terminal.
DEF BUFFER b-wm-ssd_idscan          FOR wm-ssd_idscan       .
DEF BUFFER b-wm-ssd_display         FOR wm-ssd_display      .
DEF BUFFER b-wm-ssd_task            FOR wm-ssd_task         .
DEF BUFFER b-wm-visit               FOR wm-visit            .
DEF BUFFER b-wm-visit_item          FOR wm-visit_item       .
DEF BUFFER b-wm-ssd_dialogue        FOR wm-ssd_dialogue     .
DEF BUFFER b-wm-ssd_dialogue_page   FOR wm-ssd_dialogue_page.
DEF BUFFER b-wm-ssd_dialogue_object FOR wm-ssd_dialogue_object.
DEF BUFFER b-wm-systemcode          FOR wm-systemcode.

DISABLE TRIGGERS FOR LOAD OF b-wm-ssd                .
DISABLE TRIGGERS FOR LOAD OF b-wm-ssd_compound       .
DISABLE TRIGGERS FOR LOAD OF b-wm-ssd_gac            .
DISABLE TRIGGERS FOR LOAD OF b-wm-ssd_gate           .
DISABLE TRIGGERS FOR LOAD OF b-wm-ssd_gate_terminal  .
DISABLE TRIGGERS FOR LOAD OF b-wm-ssd_idscan         .
DISABLE TRIGGERS FOR LOAD OF b-wm-ssd_display        .
DISABLE TRIGGERS FOR LOAD OF b-wm-ssd_task           .
DISABLE TRIGGERS FOR LOAD OF b-wm-visit              .
DISABLE TRIGGERS FOR LOAD OF b-wm-visit_item         .
DISABLE TRIGGERS FOR LOAD OF b-wm-ssd_dialogue       .
DISABLE TRIGGERS FOR LOAD OF b-wm-ssd_dialogue_page  .
DISABLE TRIGGERS FOR LOAD OF b-wm-ssd_dialogue_object.
DISABLE TRIGGERS FOR LOAD OF b-wm-systemcode.

DEF TEMP-TABLE tt-ssd_compound
  FIELD ssd_compoundcode AS CHAR FORMAT "x(20)" LABEL "Compound code"
  FIELD des              AS CHAR FORMAT "x(40)" LABEL "Description"
  INDEX ix1 IS UNIQUE ssd_compoundcode.
   
DEF TEMP-TABLE tt-ssd_gate
  FIELD ssd_compoundcode AS CHAR FORMAT "x(20)" LABEL "Compound code"
  FIELD ssd_gatecode     AS CHAR FORMAT "x(20)" LABEL "Gate code"
  FIELD des              AS CHAR FORMAT "x(40)" LABEL "Description"
  INDEX ix1 IS UNIQUE ssd_gatecode. 
 
DEF TEMP-TABLE tt-ssd_gate_terminal
  FIELD loc_terminalcode AS CHAR FORMAT "x(3)"  LABEL "Terminal"
  FIELD loc_companycode  AS CHAR FORMAT "x(4)"
  FIELD ssd_gatecode     AS CHAR FORMAT "x(20)" LABEL "Gate code"
  FIELD des              AS CHAR FORMAT "x(40)" LABEL "Description"
  INDEX ix1 IS UNIQUE ssd_gatecode loc_companycode loc_terminalcode. 

DEF TEMP-TABLE tt-ssd
  FIELD ssd_gatecode     AS CHAR FORMAT "x(20)"  LABEL "Gate code"
  FIELD ssd_code         AS CHAR FORMAT "x(20)"  LABEL "SSD code"
  FIELD des              AS CHAR FORMAT "x(40)"  LABEL "Description"
  FIELD ssd_companycode  AS CHAR FORMAT "x(4)"   LABEL "SSD for company"
  FIELD ssd_gaccode      AS CHAR FORMAT "x(20)"  LABEL "Gate access system"
  FIELD ssd_type         AS CHAR FORMAT "x(20)"  LABEL "SSD type"
  FIELD os_login         AS CHAR FORMAT "x(100)" LABEL "OS Login"
  FIELD ssd_dialoguecode AS CHAR 
  INDEX ix1 IS UNIQUE ssd_code.


/* ************************  Function Prototypes ********************** */

FUNCTION spGetEntry RETURNS CHARACTER 
  ( pcLabel      AS CHAR,
    pcValueList  AS CHAR,
    pcSep1       AS CHAR,
    pcSep2       AS CHAR ) FORWARD.
    
FUNCTION wmGetGenericParameter RETURNS CHARACTER
   (INPUT pcCompanycode    AS CHAR, 
    INPUT pcParameterGroup AS CHAR,
    INPUT pcParameterName  AS CHAR) FORWARD.

/* *********************** main block ********************************* */  
 
ASSIGN
  cProgram = THIS-PROCEDURE:FILE-NAME
  cAction  = "Convert self service desks (ssd)"
  cTable   = "wm-ssd"
  iTotal   = 0
  iDone    = 0.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

FIND sp-control WHERE sp-control.controlkode = "SSD-CONVERSION-1902" NO-LOCK NO-ERROR.
IF NOT AVAIL sp-control THEN RETURN.

RUN wmRemoveSSDConfiguration.
RUN wmConvertSystemCode.
RUN import-settings.
   
FOR EACH tt-ssd_compound.
  CREATE b-wm-ssd_compound.
  BUFFER-COPY tt-ssd_compound TO b-wm-ssd_compound.
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END.

FOR EACH tt-ssd_gate.
  CREATE b-wm-ssd_gate.
  BUFFER-COPY tt-ssd_gate TO b-wm-ssd_gate.
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END.
    
FOR EACH tt-ssd_gate_terminal.
  CREATE b-wm-ssd_gate_terminal.
  BUFFER-COPY tt-ssd_gate_terminal TO b-wm-ssd_gate_terminal.
    iDone = iDone + 1.
    RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END.
    
FOR EACH sp-company NO-LOCK.
  sp-companycode = sp-company.companycode.
  RUN wmConvertSSDDialogue.  
  RUN wmConvertRfConfig.
  RUN wmVisitCompound.
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END.
    
glTasksCreated = FALSE.
FOR EACH tt-ssd.
  CREATE b-wm-ssd.
  BUFFER-COPY tt-ssd TO b-wm-ssd.
  
  IF CAN-DO("ERI,KBV,KBCP", b-wm-ssd.ssd_companycode) 
  THEN b-wm-ssd.ssd_dialogue_code = CAPS(b-wm-ssd.ssd_companycode + "-" + b-wm-ssd.ssd_type).
  ELSE b-wm-ssd.ssd_dialogue_code = "SP-PRE-GATE".
  
/*  IF b-wm-ssd.ssd_usercode = "" THEN b-wm-ssd.ssd_usercode = b-wm-ssd.ssd_code.*/
  
  sp-companycode = b-wm-ssd.ssd_companycode.
  
  glTasksCreated = CAN-DO(gcDialogueList, b-wm-ssd.ssd_dialogue_code).
  IF NOT glTasksCreated THEN gcDialogueList = gcDialogueList + ( IF gcDialogueList EQ "" THEN "" ELSE "," ) + b-wm-ssd.ssd_dialogue_code. 
    
  RUN wmConvertSSDTask ("VISITOR", b-wm-ssd.ssd_code).
  RUN wmConvertSSDTask ("INTAKE" , b-wm-ssd.ssd_code).
  RUN wmConvertSSDTask ("OUTTAKE", b-wm-ssd.ssd_code).
  
  gcGacCode = b-wm-ssd.ssd_gaccode.
  IF gcGacCode <> "" THEN 
  DO.
    gcGacType   = IF gcGacCode BEGINS "PAXTON" THEN ENTRY(2, gcGacCode, "-") ELSE "GAC".
    gcGacVendor = IF gcGacCode BEGINS "PAXTON" THEN ENTRY(1, gcGacCode, "-") ELSE gcGacCode.
    CASE gcGacCode.
      WHEN "PAXTON-GAC" THEN gcGacDes = "PAXTON Gate Access Control system".   
      WHEN "PAXTON-DAC" THEN gcGacDes = "PAXTON Door Access Control system".
      WHEN "CERTUS"     THEN gcGacDes = "CERTUS Gate Operating System".
      WHEN "PARREE"     THEN gcGacDes = "PARREE Gate Access Control System".
    END CASE.
      
    FIND b-wm-ssd_gac WHERE b-wm-ssd_gac.ssd_gaccode = gcGacCode NO-ERROR.
    IF NOT AVAIL b-wm-ssd_gac THEN
      DO.
      CREATE b-wm-ssd_gac.
      ASSIGN b-wm-ssd_gac.ssd_gaccode = gcGacCode
             b-wm-ssd_gac.des         = gcGacDes
             b-wm-ssd_gac.ssd_vendor  = gcGacVendor
             b-wm-ssd_gac.ssd_gactype = gcGacType.
      END.
    END.
    
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END.
  


  

/* **********************  Internal Procedures  *********************** */

PROCEDURE wmConvertRfConfig:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF BUFFER b-wm-address FOR wm-address.
  
  DEF VAR cGateRfconfigCustomer AS CHAR NO-UNDO.
  DEF VAR iAddressNr            AS INT  NO-UNDO.
  DEF VAR cRfCode               AS CHAR NO-UNDO.
  DEF VAR iRfConfig             AS INT  NO-UNDO.
  
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
    
  cGateRfconfigCustomer = wmGetGenericParameter(?, "SSD", "GateRfconfigCustomer").
  
  IF cGateRfconfigCustomer <> "" AND cGateRfconfigCustomer <> ? THEN 
  DO.
    DO iRfConfig = 1 TO NUM-ENTRIES(cGateRfconfigCustomer) BY 2.                  
      iAddressNr = INT(ENTRY(iRfConfig, cGateRfconfigCustomer)).
      cRfCode    = ENTRY(iRfConfig + 1, cGateRfconfigCustomer).
      
      FIND b-wm-address WHERE b-wm-address.companycode = sp-companycode
                          AND b-wm-address.addressnr   = iAddressNr EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
      IF AVAIL b-wm-address THEN b-wm-address.rfconfigcode = cRfCode.                    
    END.
  END.   

  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  
END PROCEDURE.

PROCEDURE wmConvertSSDDialogue:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  
  DEF VAR cViewerList     AS CHAR NO-UNDO EXTENT 11.
  DEF VAR cViewerCodeList AS CHAR NO-UNDO EXTENT 11.
  DEF VAR cViewerDes      AS CHAR NO-UNDO.
  DEF VAR cObjectCode     AS CHAR NO-UNDO.
  DEF VAR iObjectNr       AS INT  NO-UNDO.
  DEF VAR cPageOrder      AS CHAR NO-UNDO EXTENT 6.
  DEF VAR iViewer         AS INT  NO-UNDO.
  DEF VAR cDialogue       AS CHAR NO-UNDO EXTENT 6.
  DEF VAR cDes            AS CHAR NO-UNDO EXTENT 6.
  DEF VAR iPageOrder      AS INT  NO-UNDO.
  DEF VAR iSeqNr          AS INT  NO-UNDO.
  DEF VAR cProgram        AS CHAR NO-UNDO.
  DEF VAR iDlg            AS INT  NO-UNDO.
  
  ASSIGN 
    cViewerList[01] = "v-wm-gc-languages.w"           cViewerCodeList[01] = "SP-START"       
    cViewerList[02] = "v-wm-gc-identification.w"      cViewerCodeList[02] = "SP-ID"          
    cViewerList[03] = "v-wm-gc-identification-m.w"    cViewerCodeList[03] = "SP-ID-M"        
    cViewerList[04] = "v-wm-gc-visitid.w"             cViewerCodeList[04] = "SP-ORDERLIST-1" 
    cViewerList[05] = "v-wm-gc-visitid-visitno.w"     cViewerCodeList[05] = "SP-ORDERLIST-2" 
    cViewerList[06] = "v-wm-gc-vehicle-eri.w"         cViewerCodeList[06] = "SP-VEHICLE-2"    
    cViewerList[07] = "v-wm-gc-vehicle.w"             cViewerCodeList[07] = "SP-VEHICLE-1"     
    cViewerList[08] = "v-wm-gc-cod.w"                 cViewerCodeList[08] = "SP-COD"         
    cViewerList[09] = "v-wm-gc-destination.w"         cViewerCodeList[09] = "SP-DESTINATION" 
    cViewerList[10] = "v-wm-gc-pbm.w"                 cViewerCodeList[10] = "SP-PBM"         
    cViewerList[11] = "v-wm-gc-finish.w"              cViewerCodeList[11] = "SP-FINISH".      

  CASE sp-companycode.
    WHEN  "ERI"  THEN ASSIGN cDialogue[1] = CAPS(sp-companycode) + "-PRE-GATE"          cPageOrder[1] = "1,2,3,4,5,6,8,9,10,11" cDes[1] = "ERI dialogue for PRE-GATE"
                             cDialogue[2] = CAPS(sp-companycode) + "-WEIGHBRIDGE-IN"    cPageOrder[2] = ""                      cDes[2] = "ERI dialogue for WEIGHBRIDGE IN"
                             cDialogue[3] = CAPS(sp-companycode) + "-WEIGHBRIDGE-OUT"   cPageOrder[3] = ""                      cDes[3] = "ERI dialogue for WEIGHBRIDGE OUT".
    WHEN  "KBV"  THEN ASSIGN cDialogue[1] = CAPS(sp-companycode) + "-PRE-GATE"          cPageOrder[1] = "1,4,2,3,7,11"          cDes[1] = "KBV dialogue for PRE-GATE".
    WHEN  "KBCP" THEN ASSIGN cDialogue[1] = CAPS(sp-companycode) + "-PRE-GATE"          cPageOrder[1] = ""                      cDes[1] = "KBCP dialogue for PRE-GATE"
                             cDialogue[2] = CAPS(sp-companycode) + "-GATE-IN"           cPageOrder[2] = ""                      cDes[2] = "KBCP dialogue for GATE-IN"
                             cDialogue[3] = CAPS(sp-companycode) + "-GATE-OUT"          cPageOrder[3] = ""                      cDes[3] = "KBCP dialogue for GATE-OUT"
                             cDialogue[4] = CAPS(sp-companycode) + "-GATE-IN-INTERNAL"  cPageOrder[4] = ""                      cDes[4] = "KBCP dialogue for GATE-IN-INTERNAL"
                             cDialogue[5] = CAPS(sp-companycode) + "-GATE-OUT-INTERNAL" cPageOrder[5] = ""                      cDes[5] = "KBCP dialogue for GATE-OUT-INTERNAL"
                             cDialogue[6] = CAPS(sp-companycode) + "-HELPDESK"          cPageOrder[6] = ""                      cDes[6] = "KBCP dialogue for HELPDESK".
    OTHERWISE         ASSIGN cDialogue[1] = "SP-PRE-GATE"                               cPageOrder[1] = "1,2,3,4,7,11"          cDes[1] = "Softpak dialogue for PRE-GATE".
  END CASE.
  
  DO iDlg = 1 TO EXTENT(cDialogue).
    IF cDialogue[iDlg] = "" THEN NEXT.
    FIND b-wm-ssd_dialogue WHERE b-wm-ssd_dialogue.ssd_dialogue_code = cDialogue[iDlg] NO-LOCK NO-ERROR.
  IF NOT AVAIL b-wm-ssd_dialogue THEN 
  DO.
    CREATE b-wm-ssd_dialogue.
      ASSIGN b-wm-ssd_dialogue.ssd_dialogue_code = cDialogue[iDlg]
             b-wm-ssd_dialogue.des               = cDes[iDlg].
      IF cDialogue[iDlg] = "SP-PRE-GATE" THEN b-wm-ssd_dialogue.ind_system_owned = TRUE.
    
      DO iViewer = 1 TO NUM-ENTRIES(cPageOrder[iDlg]).
        iObjectNr   = INT(ENTRY(iViewer, cPageOrder[iDlg])).
      cProgram    = "wm/object/" + cViewerList[iObjectNr].
      cObjectCode = cViewerCodeList[iObjectNr].
     
      FIND b-wm-ssd_dialogue_object WHERE b-wm-ssd_dialogue_object.ssd_dialogue_object_code = cObjectCode NO-LOCK NO-ERROR.
      IF NOT AVAIL b-wm-ssd_dialogue_object THEN 
      DO.
        CREATE b-wm-ssd_dialogue_object.
        ASSIGN b-wm-ssd_dialogue_object.applicationcode          = "WM"
               b-wm-ssd_dialogue_object.ssd_dialogue_object_code = cObjectCode
               b-wm-ssd_dialogue_object.objectsource             = cProgram
               b-wm-ssd_dialogue_object.des                      = cProgram
               b-wm-ssd_dialogue_object.objecttype               = "NORMAL".
      END.
      iPageOrder = iPageOrder + 5.
      CREATE b-wm-ssd_dialogue_page.
      ASSIGN b-wm-ssd_dialogue_page.ssd_dialogue_code        = b-wm-ssd_dialogue.ssd_dialogue_code
             b-wm-ssd_dialogue_page.ssd_dialogue_object_code = cObjectCode
             b-wm-ssd_dialogue_page.page_order               = iPageOrder. 
    END.
  END.
  END.
  
END PROCEDURE.

PROCEDURE wmConvertSSDTask:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER pcOrderTypeCode AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pcSSDCode       AS CHAR NO-UNDO.

  DEF VAR cFilterValues     AS CHARACTER NO-UNDO.
  DEF VAR cFilterDatatypes  AS CHARACTER NO-UNDO.
  DEF VAR lOk               AS LOGICAL   NO-UNDO.
  DEF VAR cReportParameters AS CHARACTER NO-UNDO.
  DEF VAR cReportCode       AS CHARACTER NO-UNDO.
  DEF VAR cReportList       AS CHARACTER NO-UNDO.
  DEF VAR iLoop             AS INTEGER   NO-UNDO.
  DEF VAR cPrinter          AS CHARACTER NO-UNDO.
  DEF VAR cPrinterList      AS CHARACTER NO-UNDO.
  DEF VAR iFilterField      AS INTEGER   NO-UNDO.
  DEF VAR cScheduler        AS CHARACTER NO-UNDO.
  DEF VAR cGateCode         AS CHARACTER NO-UNDO.
  DEF VAR cSkipReports      AS CHARACTER NO-UNDO.
  DEF VAR iTaskOrder        AS INTEGER   NO-UNDO.
  DEF VAR cReport2          AS CHARACTER NO-UNDO.
  
  DEF BUFFER b-wm-ssd FOR wm-ssd.
  
  FIND b-wm-ssd WHERE b-wm-ssd.ssd_code = pcSSDCode EXCLUSIVE-LOCK.

  FIND wm-ssd_dialogue WHERE wm-ssd_dialogue.ssd_dialogue_code = b-wm-ssd.ssd_dialogue_code NO-LOCK NO-ERROR.
  IF NOT AVAIL wm-ssd_dialogue THEN RETURN.
  FIND LAST wm-ssd_dialogue_page WHERE wm-ssd_dialogue_page.ssd_dialogue_code = wm-ssd_dialogue.ssd_dialogue_code NO-LOCK NO-ERROR.
  IF NOT AVAIL wm-ssd_dialogue_page THEN RETURN.
  
  ASSIGN cReportList  = ""
         cPrinterList = ""
         cScheduler   = "".
         
  CASE pcOrderTypeCode:
    WHEN 'VISITOR'
    THEN DO:
      cReportList  = wmGetGenericParameter(?, "SSD", "GateSpReportVisit").
      cPrinterList = wmGetGenericParameter(?, "SSD", "GateSpPrinterVisit"). 
      cReport2     = wmGetGenericParameter(?, "SSD", "GateSpReportVisit2").
      IF cReport2 <> "" THEN
      DO.
        cReportList  = cReportList  + CHR(1) + cReport2.
/*        cPrinterList = cPrinterList + CHR(1) +  spGetEntry(b-wm-ssd.os_login,wmGetGenericParameter(?, "SSD", "GateSpPrinterVisit2"),",",","). /* de eerste printer is altijd de default printer */*/
      END.  
    END.
    WHEN 'INTAKE'
    THEN DO:
      cReportList  = wmGetGenericParameter(?, "SSD", "GateSpReportIn").
      cPrinterList = wmGetGenericParameter(?, "SSD", "GateSpPrinterIn").
      cReport2     = wmGetGenericParameter(?, "SSD", "GateSpReportIn2").
      IF cReport2 <> "" THEN 
      DO.
        cReportList  = cReportList  + CHR(1) + cReport2.
/*        cPrinterList = cPrinterList + CHR(1) + spGetEntry(b-wm-ssd.os_login,wmGetGenericParameter(?, "SSD", "GateSpPrinterIn2"),",",","). /* de eerste printer is altijd de default printer */*/
      END.  
    END.
    WHEN 'OUTTAKE'
    THEN DO:
      cReportList  = wmGetGenericParameter(?, "SSD", "GateSpReportOut").
      cReport2     = wmGetGenericParameter(?, "SSD", "GateSpReportOut2").
      cPrinterList = wmGetGenericParameter(?, "SSD", "GateSpPrinterOut").
      IF cReport2 <> "" THEN 
      DO.
        cReportList  = cReportList  + CHR(1) + cReport2.
/*        cPrinterList = cprinterList + CHR(1) + spGetEntry(b-wm-ssd.os_login,wmGetGenericParameter(?, "SSD", "GateSpPrinterOut2"),",",","). /* de eerste printer is altijd de default printer */*/
      END.  
    END.
  END CASE.
  
  
  iTaskOrder = 0.

  FIND LAST b-wm-ssd_task WHERE b-wm-ssd_task.ssd_dialogue_code = wm-ssd_dialogue_page.ssd_dialogue_code
                            AND b-wm-ssd_task.page_order        = wm-ssd_dialogue_page.page_order NO-LOCK NO-ERROR.
  IF AVAIL b-wm-ssd_task THEN iTaskOrder = b-wm-ssd_task.task_order.

  DO iLoop = 1 TO NUM-ENTRIES(cReportList,CHR(1)):
    
    cReportcode = ENTRY(iLoop,cReportList,CHR(1)).
    
    IF cReportCode = "" THEN NEXT.                 
                     
    cPrinter    = ENTRY(iLoop,cPrinterList,CHR(1)).
    cScheduler  = "".
    iTaskOrder  = iTaskOrder + 10.
    
    /* Report printed by scheduler */
    IF NUM-ENTRIES(cPrinter, ";") = 2 THEN 
    DO.
      cPrinter   = ENTRY(1, cPrinter, ";").
      cScheduler = ENTRY(2, cPrinter, ";").
    END.
   
    IF NOT glTasksCreated THEN
    DO.
      CREATE b-wm-ssd_task. 
      ASSIGN b-wm-ssd_task.ssd_dialogue_code = wm-ssd_dialogue_page.ssd_dialogue_code 
             b-wm-ssd_task.page_order        = wm-ssd_dialogue_page.page_order
             b-wm-ssd_task.task_order        = iTaskOrder 
             b-wm-ssd_task.ssd_code          = ""
             b-wm-ssd_task.applicationcode   = "WM"
             b-wm-ssd_task.task_type         = "REPORT"
             b-wm-ssd_task.order_typecode    = pcOrderTypeCode
             b-wm-ssd_task.reportcode        = cReportCode
             b-wm-ssd_task.schedulerid_code  = cScheduler.
             
           IF iLoop = 1 THEN b-wm-ssd_task.ind_use_printername_1 = TRUE.
      ELSE IF iLoop = 2 THEN b-wm-ssd_task.ind_use_printername_2 = TRUE.
      
      IF b-wm-ssd_task.ind_use_printername_1 = TRUE AND
         b-wm-ssd_task.schedulerid_code      = ""   AND 
         pcOrderTypeCode <> "VISITOR" THEN b-wm-ssd_task.report_options = "PrintAttachments=yes".       
    END.
    
         IF iLoop = 1 THEN b-wm-ssd.printername_1 = cPrinter.
    ELSE IF iLoop = 2 THEN b-wm-ssd.printername_2 = cPrinter.
  END.
  
END PROCEDURE.

PROCEDURE wmConvertSystemCode:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  FIND b-wm-systemcode WHERE b-wm-systemcode.systemtype     = "SSD-TYPE"    
                         AND b-wm-systemcode.systemcode     = "WEIGHBRIDGE-IN" EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAIL b-wm-systemcode THEN 
  DO.
    CREATE b-wm-systemcode.
    ASSIGN b-wm-systemcode.systemtype     = "SSD-TYPE"
           b-wm-systemcode.systemcode     = "WEIGHBRIDGE-IN"  
           b-wm-systemcode.internal_code  = "WEIGHBRIDGE-IN"
           b-wm-systemcode.des            = "Weighbridge IN"
           b-wm-systemcode.ind_input_time = FALSE 
           b-wm-systemcode.ordernr        = 34.
  END.
  
  FIND b-wm-systemcode WHERE b-wm-systemcode.systemtype     = "SSD-TYPE"    
                         AND b-wm-systemcode.systemcode     = "WEIGHBRIDGE-OUT" EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAIL b-wm-systemcode THEN 
  DO.
    CREATE b-wm-systemcode.
    ASSIGN b-wm-systemcode.systemtype     = "SSD-TYPE"
           b-wm-systemcode.systemcode     = "WEIGHBRIDGE-OUT"  
           b-wm-systemcode.internal_code  = "WEIGHBRIDGE-OUT"
           b-wm-systemcode.des            = "Weighbridge OUT"
           b-wm-systemcode.ind_input_time = FALSE 
           b-wm-systemcode.ordernr        = 35.
  END.
  
END PROCEDURE.

PROCEDURE wmRemoveSSDConfiguration:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  FOR EACH b-wm-visit_item EXCLUSIVE.
    b-wm-visit_item.ssd_compoundcode = "".
  END.
  
  FOR EACH b-wm-visit EXCLUSIVE.
    b-wm-visit.ssd_compoundcode = "".
  END.
  
  FOR EACH b-wm-ssd_compound EXCLUSIVE.
    DELETE b-wm-ssd_compound.
  END.
  
  FOR EACH b-wm-ssd_gate_terminal EXCLUSIVE.
    DELETE b-wm-ssd_gate_terminal.
  END.
  
  FOR EACH b-wm-ssd_gate EXCLUSIVE.
    DELETE b-wm-ssd_gate.
  END.
  
  FOR EACH b-wm-ssd EXCLUSIVE.
    DELETE b-wm-ssd.
  END.
  
  FOR EACH b-wm-ssd_gac EXCLUSIVE.
    DELETE b-wm-ssd_gac.
  END.
  
  FOR EACH b-wm-ssd_display EXCLUSIVE.
    DELETE b-wm-ssd_display.
  END.
  
  FOR EACH b-wm-ssd_task EXCLUSIVE.
    DELETE b-wm-ssd_task.
  END.
  
  FOR EACH b-wm-ssd_dialogue WHERE b-wm-ssd_dialogue.ssd_dialogue_code <> "SP-DEFAULT-ORG" EXCLUSIVE.
    FOR EACH b-wm-ssd_dialogue_page WHERE b-wm-ssd_dialogue_page.ssd_dialogue_code = b-wm-ssd_dialogue.ssd_dialogue_code EXCLUSIVE.
      DELETE b-wm-ssd_dialogue_page.
    END.
    DELETE b-wm-ssd_dialogue.
  END.
  
  FOR EACH b-wm-ssd_dialogue_object EXCLUSIVE.
    IF b-wm-ssd_dialogue_object.objectsource MATCHES "*v-wm-gc*" THEN DELETE b-wm-ssd_dialogue_object.
  END. 

END PROCEDURE.

PROCEDURE wmVisitCompound:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  
  FOR EACH b-wm-visit_item WHERE b-wm-visit_item.companycode = sp-companycode EXCLUSIVE-LOCK.
  
    FIND wm-loc_terminal WHERE wm-loc_terminal.companycode      = b-wm-visit_item.companycode
                           AND wm-loc_terminal.loc_terminalcode = b-wm-visit_item.loc_terminalcode NO-LOCK NO-ERROR.
    IF AVAIL wm-loc_terminal THEN 
    DO.
      FIND FIRST wm-ssd_gate_terminal WHERE wm-ssd_gate_terminal.loc_companycode  = wm-loc_terminal.companycode 
                                        AND wm-ssd_gate_terminal.loc_terminalcode = wm-loc_terminal.loc_terminalcode NO-LOCK NO-ERROR.
      IF AVAIL wm-ssd_gate_terminal THEN 
      DO.
        FIND wm-ssd_gate WHERE wm-ssd_gate.ssd_gatecode = wm-ssd_gate_terminal.ssd_gatecode NO-LOCK NO-ERROR.
        IF AVAIL wm-ssd_gate THEN 
        DO.
          b-wm-visit_item.ssd_compoundcode = wm-ssd_gate.ssd_compoundcode.
          IF b-wm-visit_item.visit_seqnr > 0 THEN 
          DO.
            FIND b-wm-visit WHERE b-wm-visit.companycode = b-wm-visit_item.companycode 
                              AND b-wm-visit.visit_seqnr = b-wm-visit_item.visit_seqnr EXCLUSIVE-LOCK NO-ERROR.
            IF AVAIL b-wm-visit THEN b-wm-visit.ssd_compoundcode = b-wm-visit_item.ssd_compoundcode.
          END.
        END.
      END.
      ELSE b-wm-visit_item.ssd_compoundcode = "".
    END.

  END.

END PROCEDURE.

PROCEDURE import-settings:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF VAR iRow AS INT  NO-UNDO.
  DEF VAR cRow AS CHAR NO-UNDO.
  
  FIND sp-control WHERE sp-control.controlkode = "SSD-CONVERSION-1902" NO-LOCK NO-ERROR.
  IF NOT AVAIL sp-control THEN RETURN.
  
  DO iRow = 1 TO NUM-ENTRIES(sp-control.lijst, CHR(2)).
    cRow = ENTRY(iRow, sp-control.lijst, CHR(2)).
    RUN create-settings (cRow). 
  END. 

END PROCEDURE.

PROCEDURE create-settings:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER pcRow AS CHAR NO-UNDO.
  
  DEF VAR iFld   AS INT    NO-UNDO.
  DEF VAR cTable AS CHAR   NO-UNDO.
  DEF VAR hBuf   AS HANDLE NO-UNDO.
  
  ctable = ENTRY(1, pcRow, CHR(1)).
  DO TRANSACTION.
    CREATE BUFFER hBuf FOR TABLE ctable.
    hBuf:BUFFER-CREATE().
    DO iFld = 1 TO hBuf:NUM-FIELDS.
      hBuf:BUFFER-FIELD(iFld):BUFFER-VALUE = ENTRY(iFld + 1, pcRow, CHR(1)).
    END.
  END.
   
END PROCEDURE.

/* ************************  Function Implementations ***************** */

FUNCTION spGetEntry RETURNS CHARACTER 
  ( pcLabel      AS CHAR,
    pcValueList  AS CHAR,
    pcSep1       AS CHAR,
    pcSep2       AS CHAR ) :

 /*------------------------------------------------------------------------------
  Purpose:  Geeft de waarde (pcValue) van een entry uit pcValuelist 
  Voorbeeld pcLabel = C
            pcvaluelist : A=kees,C=klaas,D=piet
            pcSep1  = ","
            pcSep2  = "="
            
            Return value wordt : klaas
 ------------------------------------------------------------------------------ */

    &IF "{&USELONGCHAR}" = "yes" &THEN
      DEF VAR cValue AS LONGCHAR NO-UNDO.
    &ELSE  
      DEF VAR cValue AS CHAR NO-UNDO.
    &ENDIF
    
    DEF VAR iTel   AS INT  NO-UNDO.
    DEF VAR iPos   AS INT  NO-UNDO.

  ASSIGN pcValuelist = REPLACE(pcValuelist,pcSep2,pcSep1) WHEN (pcSep2 <> pcSep1)
         iPos = LOOKUP (pcLabel,pcValueList,pcSep1).
  IF iPos = 0 THEN RETURN cValue. /* staat niet in de lijst */
  IF iPos MODULO 2 <> 0 /* dan is het een label , anders een waarde */  
  THEN DO:
    cValue = ENTRY(iPos + 1, pcValueList,pcSep1).
  END. /* IF */
  ELSE DO:
    iTel = NUM-ENTRIES(pcValueList,pcSep1).
    DO iPos = iPos + 1 TO iTel BY 2: /* verder zoeken na gevonden waarde */
      IF ENTRY(iPos, pcValueList,pcSep1)  = pcLabel
      THEN DO: 
        cValue = ENTRY(iPos + 1, pcValueList,pcSep1).
        LEAVE. 
      END.
    END. /* DO */       
  END. /* ELSE */ 

  RETURN cValue.   /* Function return value. */
    
END FUNCTION.

FUNCTION wmGetGenericParameter RETURNS CHARACTER
   (INPUT pcCompanycode    AS CHAR, 
    INPUT pcParameterGroup AS CHAR,
    INPUT pcParameterName  AS CHAR):
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/  
  DEF VAR cValue       AS CHAR NO-UNDO.
  DEF VAR cCompanyCode AS CHAR NO-UNDO.
  
  cCompanyCode = pcCompanyCode.
  IF cCompanyCode = ? THEN cCompanyCode = sp-companycode.

  FIND wm-parameter_generic WHERE wm-parameter_generic.companycode     = cCompanyCode
                              AND wm-parameter_generic.parameter_group = pcParameterGroup
                              AND wm-parameter_generic.parameter_name  = pcParameterName NO-LOCK NO-ERROR.
  IF AVAIL wm-parameter_generic THEN
  DO.
    IF NOT wm-parameter_generic.ind_inactive THEN 
    DO.
      cValue = wm-parameter_generic.parameter_value.
      IF cValue EQ "" THEN cValue = wm-parameter_generic.parameter_initial_value.
    END.
  END.
    
  RETURN cValue.
      
END FUNCTION.


